AUI.Minimap.Pin = {}

local isInit = false

local pinManager
local mapRefresh
local playerPin
local pinBlobManager
local keepNetworkManager

local activeGroupPins = {}	

local pinId = 0

local MIN_PIN_SIZE = 18
local MIN_PIN_SCALE = 0.6
local MAX_PIN_SCALE = 1

local RESET_ANIM_ALLOW_PLAY         = 1
local RESET_ANIM_PREVENT_PLAY       = 2
local RESET_ANIM_HIDE_CONTROL       = 3
local LONG_LOOP_COUNT               = 24

local AUI_MINIMAP_PIN_DATA_DEFAULT = nil

local DEFAULT_PIN_SIZE = 18

local currentQuestTasks = {}
local nextCustomPinType = 20000
local customPins = {}

local currentQuestPinList = {}
local cyrodilMapIndex = GetCyrodiilMapIndex()
local AvAObjectiveContinuous = {}

local questPinTextures =
{
    [MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon_assisted.dds",			
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
    [MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",			
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
    [MAP_PIN_TYPE_ASSISTED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",		
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
    [MAP_PIN_TYPE_TRACKED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
    [MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon.dds",					
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",		
    [MAP_PIN_TYPE_TRACKED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_MAINSTORY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
}

local breadcrumbQuestPinTextures =
{
    [MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",			
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
    [MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",			
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
    [MAP_PIN_TYPE_ASSISTED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",		
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",		
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
    [MAP_PIN_TYPE_TRACKED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
    [MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon_door.dds",					
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",		
    [MAP_PIN_TYPE_TRACKED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",	
}		
	
local function AUI_Pin_IsNormalizedPointInsideMapBounds(x, y)
    return (x > 0 and x < 1 and y > 0 and y < 1)
end
	
AUI_KeepNetwork = ZO_Object:Subclass()
	
AUI_KeepNetwork.ALLIANCE_OWNER_ALPHA =
{
    [ALLIANCE_ALDMERI_DOMINION] = 0.4,
    [ALLIANCE_EBONHEART_PACT] = 0.4,
    [ALLIANCE_DAGGERFALL_COVENANT] = 0.4,
    [ALLIANCE_NONE] = 0.2,
}	

AUI_KeepNetwork.LINK_READY_COLOR = ZO_ColorDef:New(0, 1, 0, 0.4)
AUI_KeepNetwork.LINK_NOT_READY_COLOR = ZO_ColorDef:New(1, 1, 1, 0.2)

function AUI_KeepNetwork:New(container)
    local manager = ZO_Object.New(self)

    manager.container = container

    manager.linkPool = ZO_ControlPool:New("AUI_MapKeepLink", container, "Link")
    manager.lockPool = ZO_ControlPool:New("AUI_MapKeepLinkLock", container, "Lock")

    return manager
end	
	
function AUI_KeepNetwork:GetKeepNetworkOffset(linkX, linkY)
	local offsetX = linkX * AUI.MapData.mapContainerSize
	local offsetY = linkY * AUI.MapData.mapContainerSize		
	
	if AUI.Settings.Minimap.rotate then	
		--from the radar minimap inspired, thanks to deathangel
		local x = (offsetX - (AUI.MapData.mapContainerSize * AUI.MapData.playerX))
		local y = (offsetY - (AUI.MapData.mapContainerSize * AUI.MapData.playerY))
			
		offsetX = (math.cos(-AUI.MapData.heading) * x) - (math.sin(-AUI.MapData.heading) * y)
		offsetY = (math.sin(-AUI.MapData.heading) * x) + (math.cos(-AUI.MapData.heading) * y)			
	end
	
	return offsetX, offsetY
end	
	
function AUI_KeepNetwork:UpdateLocation(linkControl)
	local startX, startY = self:GetKeepNetworkOffset(linkControl.startNX, linkControl.startNY)
	local endX, endY = self:GetKeepNetworkOffset(linkControl.endNX, linkControl.endNY)

	linkControl:ClearAnchors()
	
	if AUI.Settings.Minimap.rotate then
		linkControl:SetAnchor(TOPLEFT, AUI_Minimap_Map_Scroll, CENTER, startX, startY)
		linkControl:SetAnchor(BOTTOMRIGHT, AUI_Minimap_Map_Scroll, CENTER, endX, endY)
	else
		ZO_Anchor_LineInContainer(linkControl, nil, startX, startY, endX, endY)	
	end
end	
	
function AUI_KeepNetwork:AddNetworkLinks()
	local linkPool = self.linkPool
	
	linkPool:ReleaseAllObjects()
	pinManager:RemovePins("restrictedLink")

	if(GetMapContentType() ~= MAP_CONTENT_AVA or GetCurrentMapIndex() ~= cyrodilMapIndex) then
		return
	end

	local showTransitLines = ZO_WorldMap_GetFilterValue(MAP_FILTER_TRANSIT_LINES) ~= false
	if(not showTransitLines) then
		return
	end

	local showOnlyMyAlliance = ZO_WorldMap_GetFilterValue(MAP_FILTER_TRANSIT_LINES_ALLIANCE) == MAP_TRANSIT_LINE_ALLIANCE_MINE

	local playerAlliance = GetUnitAlliance("player")
	local bgContext = BGQUERY_LOCAL
	local numLinks = GetNumKeepTravelNetworkLinks(bgContext)
	local historyPercent = 1.0

	for linkIndex = 1, numLinks do
		local linkType, linkOwner, restrictedToAlliance, startNX, startNY, endNX, endNY = GetHistoricalKeepTravelNetworkLinkInfo(linkIndex, bgContext, historyPercent)
		local matchesAllianceOption = not showOnlyMyAlliance or linkOwner == playerAlliance
		local r,g,b = GetAllianceColor(linkOwner):UnpackRGB()
		if(matchesAllianceOption and (AUI_Pin_IsNormalizedPointInsideMapBounds(startNX, startNY) or AUI_Pin_IsNormalizedPointInsideMapBounds(endNX, endNY))) then
			local linkControl, key = linkPool:AcquireObject()
			linkControl.startNX = startNX
			linkControl.startNY = startNY
			linkControl.endNX = endNX
			linkControl.endNY = endNY
			linkControl:SetHidden(false)		
			linkControl:SetColor(r, g, b, AUI_KeepNetwork.ALLIANCE_OWNER_ALPHA[linkOwner])

			if(linkType == FAST_TRAVEL_LINK_IN_COMBAT) then
				linkControl:SetTexture("EsoUI/Art/AvA/AvA_transitLine_dashed.dds")
			else
				linkControl:SetTexture("EsoUI/Art/AvA/AvA_transitLine.dds")
			end	

			self:UpdateLocation(linkControl)
			
			--only show alliance restrictions on uncontrolled links.
			if(linkOwner == ALLIANCE_NONE and restrictedToAlliance ~= ALLIANCE_NONE) then
				local linkCenterX = (startNX + endNX) / 2
				local linkCenterY = (startNY + endNY) / 2

				local tag = AUI_Pin.CreateRestrictedLinkTravelNetworkPinTag(restrictedToAlliance, bgContext)
				local pinType = AUI_MINIMAP_ALLIANCE_TO_RESTRICTED_PIN_TYPE[restrictedToAlliance]
				pinManager:CreatePin(pinType, tag, linkCenterX, linkCenterY)
			end			
		end
	end
end

function AUI_KeepNetwork:RefreshLinks()
	self.AddNetworkLinks(self)
end	
	
AUI_Pin = ZO_Object:Subclass()

function AUI_Pin:New()
    local pin = ZO_Object.New(self)

    local control = CreateControlFromVirtual("AUI_MapPin", AUI_MapContainer, "AUI_MapPin", pinId)
    control.m_Pin = pin
	pin.m_Control = control
	
    ZO_AlphaAnimation:New(GetControl(control, "Highlight"))
    pin:ResetAnimation(RESET_ANIM_HIDE_CONTROL)

    pinId = pinId + 1
    return pin
end

function AUI_Pin:ResetScale()
    self.targetScale = nil
    self.m_Control:SetScale(1)
    self.m_Control:SetHandler("OnUpdate", nil)
end

function AUI_Pin:ClearData()
    self.m_PinType = nil
    self.m_PinTag = nil
end

function AUI_Pin:GetControl()
    return self.m_Control
end

function AUI_Pin.HidePulseAfterFadeOut(control)
    control:SetHidden(true)
end

function AUI_Pin.DoFinalFadeInAfterPing(control)
    ZO_AlphaAnimation_GetAnimation(control):FadeIn(0, 300)
end

function AUI_Pin.DoFinalFadeOutAfterPing(control)
    ZO_AlphaAnimation_GetAnimation(control):FadeOut(0, 300)
end

function AUI_Pin:StopTextureAnimation()
    if(self.m_textureAnimTimeline)
    then
        self.m_textureAnimTimeline:Stop()
    end
end

function AUI_Pin:StopTextureAnimation()
    if(self.m_textureAnimTimeline)
    then
        self.m_textureAnimTimeline:Stop()
    end
end

function AUI_Pin:PlayTextureAnimation(loopCount)
    self:StopTextureAnimation()
    
    if not self.m_textureAnimTimeline then
        local anim
        local control = GetControl(self:GetControl(), "Background")
        anim, self.m_textureAnimTimeline = CreateSimpleAnimation(ANIMATION_TEXTURE, control)
        anim:SetImageData(32, 1)
        anim:SetFramerate(32)
        
        anim:SetHandler("OnStop", function() control:SetTextureCoords(0, 1, 0, 1) end)
    end
    self.m_textureAnimTimeline:SetPlaybackType(ANIMATION_PLAYBACK_LOOP, loopCount)
    self.m_textureAnimTimeline:PlayFromStart()
end

function AUI_Pin:ResetAnimation(resetOptions, loopCount, pulseIcon, overlayIcon, postPulseCallback, min, max)
    resetOptions = resetOptions or RESET_ANIM_PREVENT_PLAY

    local pulseControl = GetControl(self:GetControl(), "Highlight")

    if(resetOptions == RESET_ANIM_ALLOW_PLAY) then
        pulseControl:SetHidden(pulseIcon == nil)

        if(pulseIcon) then
            pulseControl:SetTexture(pulseIcon)
            postPulseCallback = postPulseCallback or AUI_Pin.DoFinalFadeOutAfterPing
            ZO_AlphaAnimation_GetAnimation(pulseControl):PingPong(.3, 1, 750, loopCount, postPulseCallback)
        end
    elseif(resetOptions == RESET_ANIM_HIDE_CONTROL) then
        ZO_AlphaAnimation_GetAnimation(pulseControl):Stop()
        pulseControl:SetHidden(true)
        self:StopTextureAnimation()
    elseif(resetOptions == RESET_ANIM_PREVENT_PLAY) then
        ZO_AlphaAnimation_GetAnimation(pulseControl):FadeOut(0, 300, ZO_ALPHA_ANIMATION_OPTION_USE_CURRENT_ALPHA, AUI_Pin.HidePulseAfterFadeOut)
    end
end

function AUI_Pin:GetPinAnchor()
	local point = CENTER
	local relToControl = AUI_MapContainer
	local rpoint = TOPLEFT
	
	local offsetX = self.normalizedX * AUI.MapData.mapContainerSize
	local offsetY = self.normalizedY * AUI.MapData.mapContainerSize	
	
	if AUI.Settings.Minimap.rotate then
		point = CENTER
		relToControl = AUI_Minimap_Map_Scroll
		rpoint = CENTER		
	
		--from the radar minimap inspired, thanks to deathangel
		local x = (offsetX - (AUI.MapData.mapContainerSize * AUI.MapData.playerX))
		local y = (offsetY - (AUI.MapData.mapContainerSize * AUI.MapData.playerY))
			
		offsetX = (math.cos(-AUI.MapData.heading) * x) - (math.sin(-AUI.MapData.heading) * y)
		offsetY = (math.sin(-AUI.MapData.heading) * x) + (math.cos(-AUI.MapData.heading) * y)			
	end
	
	return point, relToControl, rpoint, offsetX, offsetY
end

function AUI_Pin:UpdateLocation()
    local pinControl = self:GetControl()
    if(self.normalizedX and self.normalizedY) then
		local point, relToControl, rpoint, offsetX, offsetY = self:GetPinAnchor()
		
        pinControl:ClearAnchors()
		pinControl:SetAnchor(point, relToControl, rpoint, offsetX, offsetY)	

        if(self.pinBlob) then
            self.pinBlob:ClearAnchors()
			self.pinBlob:SetAnchor(point, relToControl, rpoint, offsetX, offsetY)
        end
    end
end

function AUI_Pin:UpdateAreaPinTexture()
    local pinDiameter = self.radius * 2 * AUI.MapData.mapContainerSize
    local lastPinBlobTexture = self.pinBlobTexture
    if(pinDiameter > 48) then
        if(self:IsAssisted()) then
            self.pinBlobTexture = "EsoUI/Art/MapPins/map_assistedAreaPin.dds"
        else
            self.pinBlobTexture = "EsoUI/Art/MapPins/map_areaPin.dds"
        end
    else
        if(self:IsAssisted()) then
            self.pinBlobTexture = "EsoUI/Art/MapPins/map_assistedAreaPin_32.dds"
        else
            self.pinBlobTexture = "EsoUI/Art/MapPins/map_areaPin_32.dds"
        end
    end

    if(lastPinBlobTexture ~= self.pinBlobTexture) then
        self.pinBlob:SetTexture(self.pinBlobTexture)
    end
end

function AUI_Pin:SetData(pinType, pinTag)
	self.m_PinType = pinType
	self.m_PinTag = pinTag

	local control = self.m_Control
		
	local pinData = AUI_MINIMAP_PIN_DATA[pinType]
	if pinData then
		local overlayControl = GetControl(control, "Background")
		local highlightControl = GetControl(control, "Highlight")
		local overlayTexture, pulseTexture, glowTexture = AUI.Minimap.Pin.GetPinTextureData(self, pinData.texture)
		
		if overlayTexture ~= "" then	
			overlayControl:SetTexture(overlayTexture)
		end		
				
		if pinData.tint then
			local tint = AUI.Minimap.Pin.GetPinTextureColor(self, pinData.tint)
			if tint and tint.UnpackRGBA then
				overlayControl:SetColor(tint:UnpackRGBA())
			else
				overlayControl:SetColor(1, 1, 1, 1)
			end
		else
			overlayControl:SetColor(1, 1, 1, 1)
		end				
		
		if pinData.grayscale then
			local grayscale = pinData.grayscale		
			overlayControl:SetDesaturation((type(grayscale) == "function" and grayscale(self) or grayscale) and 1 or 0)
		else
			overlayControl:SetDesaturation(0)
		end				
		 
		if pulseTexture then
			self:ResetAnimation(RESET_ANIM_ALLOW_PLAY, LONG_LOOP_COUNT, pulseTexture, overlayTexture, AUI_Pin.DoFinalFadeInAfterPing)
		elseif glowTexture then
			self:ResetAnimation(RESET_ANIM_HIDE_CONTROL)
			highlightControl:SetHidden(false)
			highlightControl:SetAlpha(1)
			highlightControl:SetTexture(glowTexture)
			highlightControl:ClearAnchors()
			highlightControl:SetAnchor(TOPLEFT, control, TOPLEFT, -5, -5)
			highlightControl:SetAnchor(BOTTOMRIGHT, control, BOTTOMRIGHT, 5, 5)
		else
			highlightControl:SetHidden(true)
		end
			
		local pinLevel = zo_max(pinData.level, 1)
			
		overlayControl:SetDrawLevel(pinLevel)
		highlightControl:SetDrawLevel(pinLevel - 1)

		if pinData.isAnimated then
			self:PlayTextureAnimation(LOOP_INDEFINITELY)
		end			
	end
end

function AUI_Pin:UpdateSize()
	local singlePinData = AUI_MINIMAP_PIN_DATA[self.m_PinType]
	if(singlePinData ~= nil) then
		local control = self.m_Control
		local hasNonZeroRadius = self.radius and self.radius > 0
		local baseSize = singlePinData.size or DEFAULT_PIN_SIZE

		if(hasNonZeroRadius) then
			local pinDiameter = self.radius * 2 * AUI.MapData.mapContainerSize

			if(singlePinData.minAreaSize and pinDiameter < singlePinData.minAreaSize) then
				pinDiameter = singlePinData.minAreaSize
			end

			self:UpdateAreaPinTexture()

			if(self.pinBlob) then
				self.pinBlob:SetDimensions(pinDiameter, pinDiameter)
				control:SetDimensions(pinDiameter, pinDiameter)
				control:SetHitInsets(0, 0, 0, 0)
			else
				control:SetDimensions(pinDiameter, pinDiameter)
				local highlightControl = control:GetNamedChild("Highlight")
				highlightControl:ClearAnchors()
				highlightControl:SetAnchorFill(control)
			end
		end

		if(not hasNonZeroRadius or singlePinData.showsPinAndArea) then
			local minSize = singlePinData.minSize or MIN_PIN_SIZE
			local scale = zo_clamp(AUI.Minimap.GetCurrentZoomValue(), MIN_PIN_SCALE, MAX_PIN_SCALE)
			local size = zo_max((baseSize * scale) / GetUIGlobalScale(), minSize)

			if self.m_PinType == MAP_PIN_TYPE_PLAYER then
				size = size * AUI.Settings.Minimap.player_pin_size
			elseif self:IsGroupLeader() then	
				size = size * AUI.Settings.Minimap.groupLeader_pin_size
			elseif self:IsGroup() then	
				size = size * AUI.Settings.Minimap.group_pin_size					
			else
				size = size * AUI.Settings.Minimap.pin_size
			end
			
			control:SetDimensions(size, size)

			local insetX = singlePinData.insetX or 0
			local insetY = singlePinData.insetY or 0
			insetX = insetX * (size / baseSize)
			insetY = insetY * (size / baseSize)

			control:SetHitInsets(insetX, insetY, -insetX, -insetY)
		end
	end
end

function AUI_Pin:SetLocation(xLoc, yLoc, radius)
    local valid = ((xLoc and yLoc) and AUI_Pin_IsNormalizedPointInsideMapBounds(xLoc, yLoc))

    local control = self:GetControl()
    control:SetHidden(not valid)

    self.normalizedX = xLoc
    self.normalizedY = yLoc
    self.radius = radius

    if valid then
        if radius and radius > 0 then
            if not self:IsKeep() then
                self.pinBlob, self.pinBlobKey = pinBlobManager:AcquireObject()
                self.pinBlob:SetHidden(false)
            end		
		
            local singlePinData = AUI_MINIMAP_PIN_DATA[self.m_PinType]
            control:GetNamedChild("Background"):SetHidden(not singlePinData.showsPinAndArea)
        else
            control:GetNamedChild("Background"):SetHidden(false)
        end

        self:UpdateLocation()
        self:UpdateSize()
    end
end

function AUI_Pin:SetRotation(angle)
    GetControl(self:GetControl(), "Background"):SetTextureRotation(angle)
end

function AUI_Pin:IsAssisted()
    return AUI_MINIMAP_ASSISTED_PIN_TYPES[self.m_PinType]
end

function AUI_Pin.CreateAvARespawnPinTag(id)
    return { id }
end

function AUI_Pin:GetAvAObjectiveObjectiveId()
    if(self:IsAvAObjective()) then
        return self.m_PinTag[2]
    end
end

function AUI_Pin:GetAvAObjectiveKeepId()
    if(self:IsAvAObjective()) then
        return self.m_PinTag[1]
    end
end

function AUI_Pin:GetKeepId()
    if(self:IsKeep()) then
        return self.m_PinTag[1]
    end
end

function AUI_Pin:IsUnderAttackPin()
    if(self:IsKeep()) then
        return self.m_PinTag[3]
    end
end

function AUI_Pin:GetBattlegroundContext()
    if(self:IsImperialCityGate()) then
        return self.m_PinTag[1]
    elseif(self:IsKeep()) then
        return self.m_PinTag[2]
    elseif(self:IsAvAObjective()) then
        return self.m_PinTag[3]
    elseif(self:IsRestrictedLink()) then
        return self.m_PinTag[2]
    end
end

function AUI_Pin:GetRestrictedAlliance()
    if(self:IsRestrictedLink()) then
        return self.m_PinTag[1]
    end
end

function AUI_Pin:GetLocationIndex()
    if(self.m_PinType == MAP_PIN_TYPE_LOCATION) then
        return self.m_PinTag[1]
    end
    
    return -1
end

function AUI_Pin:IsPOI()
    return AUI_MINIMAP_POI_PIN_TYPES[self.m_PinType]
end

function AUI_Pin:IsLocation()
    return (self.m_PinType == MAP_PIN_TYPE_LOCATION)
end

function AUI_Pin:IsQuest()
    return AUI_MINIMAP_QUEST_PIN_TYPES[self.m_PinType]
end

function AUI_Pin:IsAvAObjective()
    return AUI_MINIMAP_AVA_OBJECTIVE_PIN_TYPES[self.m_PinType] or AUI_MINIMAP_AVA_SPAWN_OBJECTIVE_PIN_TYPES[self.m_PinType]
end

function AUI_Pin:IsKeep()
    return AUI_MINIMAP_KEEP_PIN_TYPES[self.m_PinType]
end

function AUI_Pin:IsDistrict()
    return AUI_MINIMAP_DISTRICT_PIN_TYPES[self.m_PinType]
end

function AUI_Pin:IsMapPing()
    return AUI_MINIMAP_MAP_PING_PIN_TYPES[self.m_PinType]
end

function AUI_Pin:IsKillLocation()
    return AUI_MINIMAP_KILL_LOCATION_PIN_TYPES[self.m_PinType]
end

function AUI_Pin:IsFastTravelKeep()
    return AUI_MINIMAP_FAST_TRAVEL_KEEP_PIN_TYPES[self.m_PinType]
end

function AUI_Pin:IsFastTravelWayShrine()
    return AUI_MINIMAP_FAST_TRAVEL_WAYSHRINE_PIN_TYPES[self.m_PinType]
end

function AUI_Pin:IsForwardCamp()
    return AUI_MINIMAP_FORWARD_CAMP_PIN_TYPES[self.m_PinType]
end

function AUI_Pin:IsAvARespawn()
    return AUI_MINIMAP_AVA_RESPAWN_PIN_TYPES[self.m_PinType]
end

function AUI_Pin:IsImperialCityGate()
    return AUI_MINIMAP_IMPERIAL_CITY_GATE_TYPES[self.m_PinType]
end

function AUI_Pin:IsRestrictedLink()
    return AUI_MINIMAP_AVA_RESTRICTED_LINK_PIN_TYPES[self.m_PinType]
end

function AUI_Pin:IsGroup()
    return AUI_MINIMAP_GROUP_MEMBER_PIN_TYPES[self.m_PinType]
end

function AUI_Pin:IsGroupLeader()
    return AUI_MINIMAP_GROUP_LEADER_PIN_TYPES[self.m_PinType]
end

function AUI_Pin.CreateQuestPinTag(questIndex, stepIndex, conditionIndex)
    return { questIndex, conditionIndex, stepIndex }
end

function AUI_Pin.CreateForwardCampPinTag(forwardCampIndex)
    return { forwardCampIndex }
end

function AUI_Pin.CreateTravelNetworkPinTag(nodeIndex, icon, glowIcon)
    return { nodeIndex, icon, glowIcon }
end

function AUI_Pin.CreatePOIPinTag(zoneIndex, poiIndex, icon)
    return { zoneIndex, poiIndex, icon }
end

function AUI_Pin.CreateKeepPinTag(keepId, battlegroundContext, isUnderAttackPin)
    return { keepId, battlegroundContext, isUnderAttackPin }
end

function AUI_Pin.CreateKeepTravelNetworkPinTag(keepId)
    return { keepId }
end

function AUI_Pin.CreateRestrictedLinkTravelNetworkPinTag(restrictedAlliance, battlegroundContext)
    return { restrictedAlliance, battlegroundContext }
end

function AUI_Pin.CreateLocationPinTag(locationIndex, icon)
    return { locationIndex, icon }
end

function AUI_Pin.CreateAvAObjectivePinTag(keepId, objectiveId, battlegroundContext)
    return { keepId, objectiveId, battlegroundContext }
end

function AUI_Pin.CreateImperialCityPinTag(battlegroundContext, linkedCollectibleIsLocked)
    return { battlegroundContext, linkedCollectibleIsLocked }
end

function AUI_Pin:IsImperialCityPin()
    return self:IsAvARespawn() or self:IsDistrict()
end

function AUI_Pin:IsCyrodiilPin()
    return self:IsAvAObjective() or self:IsAvARespawn() or self:IsForwardCamp() or self:IsFastTravelKeep() or self:IsKeep() or self:IsImperialCityGate()
end

function AUI_Pin:IsAvAPin()
    return self:IsImperialCityPin() or self:IsCyrodiilPin()
end

function AUI_Pin:ValidateAVAPinAllowed()
    if self:IsAvAPin() then
        if GetMapContentType() == MAP_CONTENT_AVA then
            local currentMapIndex = GetCurrentMapIndex()
            if currentMapIndex == GetCyrodiilMapIndex() then
                return self:IsCyrodiilPin()
            elseif currentMapIndex == GetImperialCityMapIndex() then
                return self:IsImperialCityPin()
            end
        end
		
        return false
    end
	
    return true
end

function AUI_Pin:GetPOIIndex()
    if self:IsPOI() then
        return self.m_PinTag[2]
    end

    return -1
end

function AUI_Pin:GetPOIZoneIndex()
    if self:IsPOI() then
        return self.m_PinTag[1]
    end

    return -1
end

function AUI_Pin:GetQuestIndex()
    if self:IsQuest() then
        return self.m_PinTag[1]
    end

    return -1
end

function AUI_Pin:GetFastTravelIcons()
    if self:IsFastTravelWayShrine() then
        return self.m_PinTag[2], nil, self.m_PinTag[3]
    end

    return ""
end

function AUI_Pin:GetPOIIcon()
    if self:IsPOI() then
        return self.m_PinTag[3]
    end

    return ""
end

function AUI_Pin:GetLocationIcon()
    if self.m_PinType == MAP_PIN_TYPE_LOCATION then
        return self.m_PinTag[2]
    end

    return ""
end

function AUI_Pin:GetFastTravelKeepId()
    if self:IsFastTravelKeep() then
        return self.m_PinTag[1]
    end
end

function AUI_Pin:IsLockedByLinkedCollectible()
    if self:IsPOI() or self:IsFastTravelWayShrine() then
        return self.m_PinTag[4]
    elseif  self:IsImperialCityGate() then
        return self.m_PinTag[2]
    end
	
    return false
end

function AUI_Pin:GetPinType()
    return self.m_PinType
end

function AUI_Pin:GetQuestIcon()
	if self.m_PinTag and self.m_PinTag.isBreadcrumb then
		return breadcrumbQuestPinTextures[self:GetPinType()]
	else
		return questPinTextures[self:GetPinType()]
	end
end

AUI_MapPin = ZO_ObjectPool:Subclass()

function AUI_MapPin:New()
    local factory = function(pool) return AUI_Pin:New() end
    local reset =   function(pin)
                        pin:ClearData()

                        local pinControl = pin:GetControl()
                        pinControl:SetHidden(true)

                        pin:ResetAnimation(RESET_ANIM_HIDE_CONTROL)
                        pin:ResetScale()
						
                        if pin.pinBlobKey then
                            pinBlobManager:ReleaseObject(pin.pinBlobKey)
                            pin.pinBlobKey = nil
                            pin.pinBlob = nil
                        end						
                    end

    local mapPins = ZO_ObjectPool.New(self, factory, reset)

    mapPins.m_keyToPinMapping =
    {
        ["poi"] = {},
        ["loc"] = {},
        ["quest"] = {}, 
        ["ava"] = {},
        ["keep"] = {},
        ["imperialCity"] = {},
        ["pings"] = {},
        ["killLocation"] = {},
        ["fastTravelWayshrine"] = {},
        ["forwardCamp"] = {},
        ["group"] = {},
        ["restrictedLink"] = {},
		["custom"] = {},
    }
	
    return mapPins
end

function AUI_MapPin:GetNextCustomPinType()
    nextCustomPinType = nextCustomPinType + 1
    return nextCustomPinType
end

function AUI_MapPin:AddCustomPinType(pinData, callback)
	if not pinData then
		return nil
	end

	local pinTypeId = self:GetNextCustomPinType()

	AUI_MINIMAP_PIN_DATA[pinTypeId] = AUI.Table.Copy(pinData)
	AUI_MINIMAP_PIN_DATA[pinTypeId].custom = true
	AUI_MINIMAP_PIN_DATA[pinTypeId].callback = callback
	
	AUI_MINIMAP_PIN_DATA_DEFAULT[pinTypeId] = AUI_MINIMAP_PIN_DATA[pinTypeId]
	
	return pinTypeId
end

function AUI_MapPin:CreateCustomPin(pinTypeId, pinTag, normX, normY, radius)	
	if not pinTypeId or not pinTag or not normX or not normY then
		return
	end

	pinManager:RemovePins("custom", pinTypeId, pinTag)
	pinManager:CreatePin(pinTypeId, pinTag, normX, normY, radius)
end

function AUI_MapPin:RefreshCustomPinsByType(_pinTypeId)
	pinManager:RemovePins("custom", _pinTypeId)

	if not AUI.Minimap.IsShow() or ZO_WorldMap_IsWorldMapShowing() then
		return
	end
	
	for pinTypeId, pinData in pairs(AUI_MINIMAP_PIN_DATA) do
		if pinData.custom then
			if not _pinTypeId or pinTypeId == _pinTypeId then
				if pinData.callback then
					pinData.callback("AUI", pinTypeId)						
				end
			end
		end
	end	
end

function AUI_MapPin:RemoveCustomPinsByType(pinTypeId)	
	pinManager:RemovePins("custom", pinTypeId)
end

function AUI_MapPin:AddTask(taskId, data)
    if taskId then
        currentQuestTasks[taskId] = data
    end
end

function AUI_MapPin:ClearPendingTasksForQuest(questIndex)
    for key, data in pairs(currentQuestTasks) do
        if(data[1] == questIndex) then
            currentQuestTasks[key] = nil
        end
    end
end

function AUI_MapPin:ClearPendingTasks()
    currentQuestTasks = {}
end

function AUI_MapPin:CreatePin(pinType, pinTag, xLoc, yLoc, radius)
    local pin, pinKey = self:AcquireObject()
	
	pin:SetData(pinType, pinTag)
	pin:SetLocation(xLoc, yLoc, radius)	
	
	local valid = pin:ValidateAVAPinAllowed()	
	if valid then
		if pin:IsPOI() then
			valid = self:MapPinLookupToPinKey("poi", pin:GetPOIZoneIndex(), pin:GetPOIIndex(), pinKey)
		elseif pin:IsLocation() then
			valid = self:MapPinLookupToPinKey("loc", pin:GetLocationIndex(), pin:GetLocationIndex(), pinKey)
		elseif pin:IsQuest() then
			valid = self:MapPinLookupToPinKey("quest", pin:GetQuestIndex(), pinTag, pinKey)
		elseif pin:IsAvAObjective() then
			valid = self:MapPinLookupToPinKey("ava", pin:GetAvAObjectiveKeepId(), pinTag, pinKey)
		elseif pin:IsKeep()  then
			valid = self:MapPinLookupToPinKey("keep", pin:GetKeepId(), pin:IsUnderAttackPin(), pinKey)
		elseif pin:IsImperialCityGate()  then
			valid = self:MapPinLookupToPinKey("imperialCity", pinType, pinTag, pinKey)		
		elseif pin:IsMapPing()  then
			valid = self:MapPinLookupToPinKey("pings", pinType, pinTag, pinKey)
		elseif pin:IsKillLocation()  then
			valid = self:MapPinLookupToPinKey("killLocation", pinType, pinTag, pinKey)
		elseif pin:IsFastTravelWayShrine() then
			valid = self:MapPinLookupToPinKey("fastTravelWayshrine", pinType, pinTag, pinKey)
		elseif pin:IsForwardCamp() then
			valid = self:MapPinLookupToPinKey("forwardCamp", pinType, pinTag, pinKey)
		elseif pin:IsAvARespawn() then
			valid = self:MapPinLookupToPinKey("AvARespawn", pinType, pinTag, pinKey)
		elseif pin:IsGroup() or pin:IsGroupLeader() then
			valid = self:MapPinLookupToPinKey("group", pinType, pinTag, pinKey)
		elseif pin:IsRestrictedLink() then
			valid = self:MapPinLookupToPinKey("restrictedLink", pinType, pinTag, pinKey)		
		else
			local pinData = AUI_MINIMAP_PIN_DATA[pinType]
			if pinData and pinData.custom then
				valid = self:MapPinLookupToPinKey("custom", pinType, pinTag, pinKey)
			end		
		end
	end
	
	if not valid then
		self:ReleaseObject(pinKey)
	end
	
    return pin, pinKey
end

function AUI_MapPin:FindPin(lookupType, majorIndex, keyIndex)
    local lookupTable = self.m_keyToPinMapping[lookupType]
    local keys = lookupTable[majorIndex]
    if keys ~= nil then
        local pinKey = keys[keyIndex]
        if pinKey then
            return self:GetExistingObject(pinKey)
        end
    end
end

function AUI_MapPin:MapPinLookupToPinKey(lookupType, majorIndex, keyIndex, pinKey)
	if lookupType == nil or majorIndex == nil or keyIndex == nil or pinKey == nil then	
		return false
	end

    local lookupTable = self.m_keyToPinMapping[lookupType]

    if not lookupTable[majorIndex] then
        lookupTable[majorIndex] = {}
        lookupTable[majorIndex] = lookupTable[majorIndex]
    end

    lookupTable[majorIndex][keyIndex] = pinKey
	
	return true
end

function AUI_MapPin:RemovePins(lookupType, majorIndex, keyIndex)
    local lookupTable = self.m_keyToPinMapping[lookupType]

    if majorIndex then
        local keys = lookupTable[majorIndex]
        if keys then
            if keyIndex then
                local pinKey = keys[keyIndex]
                if pinKey then
                    self:ReleaseObject(pinKey)
                    keys[keyIndex] = nil
                end
            else
                for _, pinKey in pairs(keys) do
                    self:ReleaseObject(pinKey)
                end

                self.m_keyToPinMapping[lookupType][majorIndex] = {}
            end
        end
    else
        for _, keys in pairs(lookupTable) do
            for _, pinKey in pairs(keys) do
                self:ReleaseObject(pinKey)
            end
        end

        self.m_keyToPinMapping[lookupType] = {}
    end
end

local mapsWithoutQuestPins =
{
    [MAPTYPE_WORLD] = true,
    [MAPTYPE_ALLIANCE] = true,
    [MAPTYPE_COSMIC] = true,
}

local function AUI_MapPin_AddQuestTask(questIndex)
    if(ZO_WorldMap_IsPinGroupShown(MAP_FILTER_QUESTS)) then
        local assisted = GetTrackedIsAssisted(TRACK_TYPE_QUEST, questIndex)

        if(GetJournalQuestIsComplete(questIndex)) then
            local taskId = RequestJournalQuestConditionAssistance(questIndex, QUEST_MAIN_STEP_INDEX, 1, false)
            local tag = AUI_Pin.CreateQuestPinTag(questIndex, QUEST_MAIN_STEP_INDEX, 1)
            pinManager:AddTask(taskId, tag)
        else
            for stepIndex = QUEST_MAIN_STEP_INDEX, GetJournalQuestNumSteps(questIndex) do
                for conditionIndex = 1, GetJournalQuestNumConditions(questIndex, stepIndex) do
                    local _, _, isFailCondition, isComplete = GetJournalQuestConditionValues(questIndex, stepIndex, conditionIndex)
                    if(not (isFailCondition or isComplete)) then
                        local taskId = RequestJournalQuestConditionAssistance(questIndex, stepIndex, conditionIndex, assisted)
                        local tag = AUI_Pin.CreateQuestPinTag(questIndex, stepIndex, conditionIndex)
                        pinManager:AddTask(taskId, tag)
                    end
                end
            end
        end
    end
end	

local function AUI_MapPin_RefreshSingleQuestPin(questIndex)
    pinManager:RemovePins("quest", questIndex)
    pinManager:ClearPendingTasksForQuest(questIndex)
    AUI_MapPin_AddQuestTask(questIndex)
end

local function AUI_MapPin_RefreshQuestPins()
    pinManager:RemovePins("quest")
	pinManager:ClearPendingTasks()
    if(mapsWithoutQuestPins[GetMapType()] ~= nil) then return end

	for i = 1, MAX_JOURNAL_QUESTS do
		local questIndex = i
		AUI_MapPin_AddQuestTask(questIndex)
	end
end

local function AUI_MapPin_AddQuestPin(taskId, pinType, xLoc, yLoc, areaRadius, insideCurrentMapWorld, isBreadcrumb)	
	local pinTag = currentQuestTasks[taskId]
	if(pinTag and insideCurrentMapWorld and AUI_Pin_IsNormalizedPointInsideMapBounds(xLoc, yLoc)) then	
		local questIndex = pinTag[1]
		if questIndex then	
			pinTag.isBreadcrumb = isBreadcrumb
			local questType = GetJournalQuestType(questIndex)
			local questRepeatType = GetJournalQuestRepeatType(questIndex)			
			local questPinType =  AUI.Minimap.Pin.GetQuestPinType(pinType, questType, questRepeatType)	
			pinManager:CreatePin(questPinType, pinTag, xLoc, yLoc, areaRadius)		
		end	
		currentQuestTasks[taskId] = nil
	end
end

local function AUI_MapPin_RefreshAvAObjectives()
    pinManager:RemovePins("ava")
    AvAObjectiveContinuous = {}

    if GetMapContentType() == MAP_CONTENT_AVA then
		local numObjectives = GetNumAvAObjectives()

		local worldMapAvAPinsShown = ZO_WorldMap_IsPinGroupShown(MAP_FILTER_AVA_OBJECTIVES)

		for i = 1, numObjectives do
			local keepId, objectiveId, _ = GetAvAObjectiveKeysByIndex(i)
			if(ZO_WorldMap_IsObjectiveShown(keepId, objectiveId, BGQUERY_LOCAL)) then
				local pinType, currentX, currentY, continuousUpdate = GetHistoricalAvAObjectivePinInfo(keepId, objectiveId, BGQUERY_LOCAL, 1)
				if(pinType ~= MAP_PIN_TYPE_INVALID) then
					if(worldMapAvAPinsShown) then				
						if(AUI_Pin_IsNormalizedPointInsideMapBounds(currentX, currentY)) then
							local tag = AUI_Pin.CreateAvAObjectivePinTag(keepId, objectiveId, BGQUERY_LOCAL)
							local _, pinKey = pinManager:CreatePin(pinType, tag, currentX, currentY)

							if(continuousUpdate) then
								AvAObjectiveContinuous[i] = pinKey
							end
						end
					end
				end
			end
		end
	end
end

function AUI_MapPin_RefreshKillLocations()
    pinManager:RemovePins("killLocation")
    RemoveMapPinsInRange(MAP_PIN_TYPE_TRI_BATTLE_SMALL, MAP_PIN_TYPE_EBONHEART_VS_DAGGERFALL_LARGE)

	if(ZO_WorldMap_IsPinGroupShown(MAP_FILTER_KILL_LOCATIONS)) then	
		for i = 1, GetNumKillLocations() do
			local pinType, normalizedX, normalizedY = GetKillLocationPinInfo(i)
			if(pinType ~= MAP_PIN_TYPE_INVALID) then
				if(AUI_Pin_IsNormalizedPointInsideMapBounds(normalizedX, normalizedY)) then
					pinManager:CreatePin(pinType, i, normalizedX, normalizedY)
				end
			end
		end
	end
end

function AUI_MapPin_RefreshForwardCamps()
    pinManager:RemovePins("forwardCamp")

    if(GetMapContentType() ~= MAP_CONTENT_AVA) then
        return
    end
	
	if(not ZO_WorldMap_IsPinGroupShown(MAP_FILTER_AVA_GRAVEYARDS)) then return end

    for i = 1, GetNumForwardCamps(BGQUERY_LOCAL) do
        local pinType, normalizedX, normalizedY, normalizedRadius = GetForwardCampPinInfo(BGQUERY_LOCAL, i)
        if(AUI_Pin_IsNormalizedPointInsideMapBounds(normalizedX, normalizedY)) then
            if(not ZO_WorldMap_IsPinGroupShown(MAP_FILTER_AVA_GRAVEYARD_AREAS)) then
                normalizedRadius = 0
            end		
		
            pinManager:CreatePin(pinType, AUI_Pin.CreateForwardCampPinTag(i), normalizedX, normalizedY, normalizedRadius)
        end
    end
end

local function AUI_MapPin_RefreshMapPings()
    pinManager:RemovePins("pings")

    if(GetMapType() == MAPTYPE_COSMIC) then return end

    for i = 1, GROUP_SIZE_MAX do
        local unitTag = ZO_Group_GetUnitTagForGroupIndex(i)
        local x, y = GetMapPing(unitTag)

        if(x ~= 0 and y ~= 0) then
            pinManager:CreatePin(MAP_PIN_TYPE_PING, unitTag, x, y)
        end
    end

    local x, y = GetMapRallyPoint()

    if(x ~= 0 and y ~= 0) then
        pinManager:CreatePin(MAP_PIN_TYPE_RALLY_POINT, "rally", x, y)
    end

    x, y = GetMapPlayerWaypoint()
    if(x ~= 0 and y ~= 0) then
        pinManager:CreatePin(MAP_PIN_TYPE_PLAYER_WAYPOINT , "waypoint", x, y)
    end
end

local function AUI_MapPin_RefreshWayshrines()
	pinManager:RemovePins("fastTravelWayshrine")

	if not ZO_WorldMap_IsPinGroupShown(MAP_FILTER_WAYSHRINES) then return end

	for nodeIndex = 1, GetNumFastTravelNodes() do
		local known, name, normalizedX, normalizedY, icon, glowIcon, poiType, isLocatedInCurrentMap, linkedCollectibleIsLocked = GetFastTravelNodeInfo(nodeIndex)	

		if known and isLocatedInCurrentMap and AUI_Pin_IsNormalizedPointInsideMapBounds(normalizedX, normalizedY) then		
			local tag = AUI_Pin.CreateTravelNetworkPinTag(nodeIndex, icon, glowIcon, linkedCollectibleIsLocked)

			local pinType = MAP_PIN_TYPE_FAST_TRAVEL_WAYSHRINE

			pinManager:CreatePin(pinType, tag, normalizedX, normalizedY)
		end
	end
end

function AUI_MapPin_RefreshImperialCity()
    pinManager:RemovePins("imperialCity")
	
    if GetMapContentType() == MAP_CONTENT_AVA and GetMapFilterType() == MAP_FILTER_TYPE_AVA_CYRODIIL and ZO_WorldMap_IsPinGroupShown(MAP_FILTER_IMPERIAL_CITY_ENTRANCES) then
        local hasAccess = DoesAllianceHaveImperialCityAccess(GetCurrentCampaignId(), GetUnitAlliance("player"))
        local icPinType = hasAccess and MAP_PIN_TYPE_IMPERIAL_CITY_OPEN or MAP_PIN_TYPE_IMPERIAL_CITY_CLOSED
        local collectibleId = GetImperialCityCollectibleId()
        local linkedCollectibleIsLocked = not IsCollectibleUnlocked(collectibleId)
        for _, coords in ipairs(AUI_IC_PIN_POSITIONS) do
            local tag = AUI_Pin.CreateImperialCityPinTag(BGQUERY_LOCAL, linkedCollectibleIsLocked)
            pinManager:CreatePin(icPinType, tag, coords[1], coords[2])
        end
    end
end

local function AddKeep(keepId)
    local historyPercent = 1.0
    local pinType, locX, locY = GetHistoricalKeepPinInfo(keepId, BGQUERY_LOCAL, historyPercent)
    if pinType ~= MAP_PIN_TYPE_INVALID then
        local keepUnderAttack = GetHistoricalKeepUnderAttack(keepId, BGQUERY_LOCAL, historyPercent)
		local keepUnderAttackPinType = ZO_WorldMap_GetUnderAttackPinForKeepPin(pinType)
        if AUI_Pin_IsNormalizedPointInsideMapBounds(locX, locY) then
            local keepType = GetKeepType(keepId)
            if ZO_WorldMap_IsPinGroupShown(MAP_FILTER_RESOURCE_KEEPS or keepType ~= KEEPTYPE_RESOURCE) then	
				local underAttackPin = true
				local notUnderAttackPin = false
				local existingKeepPin = pinManager:FindPin("keep", keepId, notUnderAttackPin)
					
				if not existingKeepPin then
					local tag = AUI_Pin.CreateKeepPinTag(keepId, BGQUERY_LOCAL, notUnderAttackPin)
					
					pinManager:CreatePin(pinType, tag, locX, locY)

					if keepUnderAttack then
						tag = AUI_Pin.CreateKeepPinTag(keepId, BGQUERY_LOCAL, underAttackPin)
						pinManager:CreatePin(keepUnderAttackPinType, tag, locX, locY)
					end
				end 
            end
        end
    end
end

local function AUI_MapPin_RefreshKeeps(keepId)
    pinManager:RemovePins("keep", keepId)

	if GetMapContentType() == MAP_CONTENT_AVA then
		if keepId then
			AddKeep(keepId)
		else	
			local numKeeps = GetNumKeeps()
			for i = 1, numKeeps do
				local keepId, bgContext = GetKeepKeysByIndex(i)
				if IsLocalBattlegroundContext(bgContext) then
					AddKeep(keepId)
				end
			end
		end
	end
end

local function CreateSinglePOIPin(zoneIndex, poiIndex)
    local xLoc, zLoc, iconType, icon, isShownInCurrentMap = GetPOIMapInfo(zoneIndex, poiIndex)

	if isShownInCurrentMap then
		if not AUI_MINIMAP_POI_PIN_TYPES[iconType] and AUI.Settings.Minimap.previewUnknownPins then
			iconType = AUI_MINIMAP_PIN_TYPE_POI_UNKNOWN
			icon = AUI_MINIMAP_PIN_DATA[iconType].texture
		end	
	
		if AUI_MINIMAP_POI_PIN_TYPES[iconType] then
			local tag = AUI_Pin.CreatePOIPinTag(zoneIndex, poiIndex, icon)
			pinManager:CreatePin(iconType, tag, xLoc, zLoc)
		end
	end
end

local function RefreshSinglePOI(zoneIndex, poiIndex)
    pinManager:RemovePins("poi", zoneIndex, poiIndex)

    if(ZO_WorldMap_IsPinGroupShown(MAP_FILTER_OBJECTIVES)) then
        CreateSinglePOIPin(zoneIndex, poiIndex)
    end
end

function AUI_MapPin_RefreshAllPOIs()
    pinManager:RemovePins("poi")
	
	if(ZO_WorldMap_IsPinGroupShown(MAP_FILTER_OBJECTIVES)) then
		local zoneIndex = GetCurrentMapZoneIndex()
		for i = 1, GetNumPOIs(zoneIndex) do
			CreateSinglePOIPin(zoneIndex, i)
		end
	end
end

local function AUI_MapPin_GetUnitState(pinTag)
	local groupSize = GetGroupSize()
	
	local unitTag = nil
	for i=1, groupSize do
		unitTag = GetGroupUnitTagByIndex(i)	
		
		if unitTag == pinTag then	
			if IsUnitDead(unitTag) == true then
				return AUI_MINIMAP_UNIT_DEAD, IsUnitFriend(unitTag) 
			elseif IsUnitInCombat(unitTag) == true then
				return AUI_MINIMAP_UNIT_IN_COMBAT, IsUnitFriend(unitTag) 
			end
			break
		end
	end

	return AUI_MINIMAP_UNIT_NORMAL, IsUnitFriend(unitTag) 
end

local function AUI_MapPin_IsGroupPinAllowed(_unitTag)
	return AUI.Unit.IsGroupUnitTag(_unitTag) and IsUnitGrouped(_unitTag) and IsUnitOnline(_unitTag) and DoesUnitExist(_unitTag) and not AreUnitsEqual("player", _unitTag)
end

local function AUI_MapPin_AddGroupPin(_unitTag)	
	local pinType = AUI.Minimap.Pin.GetGroupStatePinType(_unitTag)	
	local x, y = GetMapPlayerPosition(_unitTag)	
	local _, pinKey = pinManager:CreatePin(pinType, _unitTag, x, y)

	activeGroupPins[_unitTag] = pinKey
end

function AUI_MapPin_RefreshGroupPins(_unitTag)
    if ZO_WorldMap_IsPinGroupShown(MAP_FILTER_GROUP_MEMBERS) then
		local groupSize = GetGroupSize()
		
		activeGroupPins = {}
		pinManager:RemovePins("group")
		
		for i = 1, groupSize do
			local unitTag =  GetGroupUnitTagByIndex(i)
			if AUI_MapPin_IsGroupPinAllowed(unitTag) then
				AUI_MapPin_AddGroupPin(unitTag)
			end
		end
	else
		activeGroupPins = {}
		pinManager:RemovePins("group")	
    end
end

local function AUI_MapPin_UpdateGroupPins()
	for unitTag, pinKey in pairs(activeGroupPins) do			
		local pin = pinManager:GetExistingObject(pinKey)
		if pin and AUI_MapPin_IsGroupPinAllowed(unitTag) then
			local x, y = GetMapPlayerPosition(unitTag)	
			local pinType = AUI.Minimap.Pin.GetGroupStatePinType(unitTag)
			pin:SetData(pinType, unitTag)
			pin:SetLocation(x, y)
		end
	end
end

function AUI_MapPin_RefreshLocations()
    pinManager:RemovePins("loc")

    for i = 1, GetNumMapLocations() do
		if(IsMapLocationVisible(i)) then    
			local icon, x, y = GetMapLocationIcon(i)
    
			if(icon ~= "" and AUI_Pin_IsNormalizedPointInsideMapBounds(x, y)) then
				local tag = AUI_Pin.CreateLocationPinTag(i, icon)
				pinManager:CreatePin(MAP_PIN_TYPE_LOCATION, tag, x, y)
			end
		end
    end
end

AUI_PinBlobManager = ZO_ObjectPool:Subclass()

function AUI_PinBlobManager:New(blobContainer)
    local blobFactory = function(pool) return ZO_ObjectPool_CreateNamedControl("AUI_QuestPinBlob", "AUI_PinBlob", pool, blobContainer) end
    return ZO_ObjectPool.New(self, blobFactory, ZO_ObjectPool_DefaultResetControl)
end

local EVENT_HANDLERS =
{
	[EVENT_POI_UPDATED] = function(eventCode, zoneIndex, poiIndex)
		RefreshSinglePOI(zoneIndex, poiIndex)
		AUI_MapPin_RefreshLocations()
	end,
	[EVENT_COLLECTIBLE_UPDATED] = function(eventCode, collectibleId)
		AUI_MapPin_RefreshAllPOIs()
		AUI_MapPin_RefreshWayshrines()
		if collectibleId == GetImperialCityCollectibleId() and cyrodiilMapIndex == GetCurrentMapIndex() then
			AUI_MapPin_RefreshImperialCity()
		end		
	end,	
	[EVENT_MAP_PING] = function(eventCode, pingEventType, pingType, pingTag, x, y)
		if pingEventType == PING_EVENT_ADDED then
			pinManager:RemovePins("pings", pingType, pingTag)
			pinManager:CreatePin(pingType, pingTag, x, y)
		elseif(pingEventType == PING_EVENT_REMOVED) then
			pinManager:RemovePins("pings", pingType, pingTag)
		end
	end,		
	[EVENT_OBJECTIVES_UPDATED] = AUI_MapPin_RefreshAvAObjectives,
	[EVENT_OBJECTIVE_CONTROL_STATE] = AUI_MapPin_RefreshAvAObjectives,
	[EVENT_ZONE_SCORING_CHANGED] = AUI_MapPin_RefreshAvAObjectives,	
	[EVENT_KILL_LOCATIONS_UPDATED] = AUI_MapPin_RefreshKillLocations,
	[EVENT_FAST_TRAVEL_NETWORK_UPDATED] = AUI_MapPin_RefreshWayshrines,
	[EVENT_FAST_TRAVEL_KEEP_NETWORK_UPDATED] = function() if keepNetworkManager then keepNetworkManager:RefreshLinks() end end,
}

function AUI.Minimap.Pin.Init()
	if isInit == false then	
		pinManager = AUI_MapPin:New()
		mapRefresh = ZO_Refresh:New()
		pinBlobManager = AUI_PinBlobManager:New(AUI_MapContainer)
		keepNetworkManager = AUI_KeepNetwork:New(AUI_MapContainer)	
		playerPin = pinManager:CreatePin(MAP_PIN_TYPE_PLAYER, "player")	
	
		AUI_MINIMAP_PIN_DATA_DEFAULT = AUI.Table.Copy(AUI_MINIMAP_PIN_DATA)
		
		AUI.Minimap.Pin.SetPinData()	

		for event, handler in pairs(EVENT_HANDLERS) do
			EVENT_MANAGER:RegisterForEvent("AUI_MapPin", event, handler)
		end

		isInit = true
	end
end

function AUI.Minimap.Pin.GetQuestPinType(pinType, questType, questRepeatType)
	if not AUI.Minimap.IsLoaded() then
		return
	end

	local questPinType = pinType

	if questType == QUEST_TYPE_MAIN_STORY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_MAINSTORY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_MAINSTORY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_MAINSTORY			
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_MAINSTORY						
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_MAINSTORY			
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_MAINSTORY				
		end
	elseif questType == QUEST_TYPE_NONE and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DAILY					
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DAILY			
		end	
	elseif questType == QUEST_TYPE_CRAFTING and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_DAILY
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_DAILY				
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_DAILY		
		end	
	elseif questType == QUEST_TYPE_CLASS and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_DAILY	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_DAILY					
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_DAILY		
		end	
	elseif questType == QUEST_TYPE_GUILD and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_DAILY	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_DAILY				
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_DAILY		
		end	
	elseif questType == QUEST_TYPE_DUNGEON and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_DAILY	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_DAILY			
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_DAILY		
		end	
	elseif questType == QUEST_TYPE_RAID and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_DAILY
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_DAILY		
		end	
	elseif questType == QUEST_TYPE_GROUP and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_DAILY
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_DAILY	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_DAILY	
		end
	elseif questType == QUEST_TYPE_NONE and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_REPEATABLE	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_REPEATABLE					
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_REPEATABLE		
		end	
	elseif questType == QUEST_TYPE_CRAFTING and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_REPEATABLE				
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_REPEATABLE		
		end	
	elseif questType == QUEST_TYPE_CLASS and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_REPEATABLE	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_REPEATABLE					
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_REPEATABLE		
		end	
	elseif questType == QUEST_TYPE_GUILD and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_REPEATABLE	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_REPEATABLE				
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_REPEATABLE	
		end	
	elseif questType == QUEST_TYPE_DUNGEON and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_REPEATABLE			
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_REPEATABLE	
		end	
	elseif questType == QUEST_TYPE_RAID and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_REPEATABLE		
		end	
	elseif questType == QUEST_TYPE_GROUP and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_REPEATABLE	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			questPinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_REPEATABLE	
		end
	end	

	return questPinType
end

function AUI.Minimap.Pin.GetGroupStatePinType(groupTag)
	if not AUI.Minimap.IsLoaded() then
		return
	end

	local pinType = MAP_PIN_TYPE_GROUP
			
	local isLeader = IsUnitGroupLeader(groupTag)
	local unitState, isFriend = AUI_MapPin_GetUnitState(groupTag)

	if isLeader == true then
		if unitState == AUI_MINIMAP_UNIT_IN_COMBAT and AUI.Settings.Minimap.showGroupMemberStatus then	
			if isFriend == true then
				pinType = AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_IN_COMBAT				
			else					
				pinType = AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_IN_COMBAT
			end
		elseif unitState == AUI_MINIMAP_UNIT_DEAD and AUI.Settings.Minimap.showGroupMemberStatus then	
			if isFriend == true then
				pinType = AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_DEAD				
			else					
				pinType = AUI_MINIMAP_PIN_TYPE_GROUP_DEAD
			end
		elseif unitState == AUI_MINIMAP_UNIT_NORMAL or not AUI.Settings.Minimap.showGroupMemberStatus then
			if isFriend == true then
				pinType = AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND				
			else					
				pinType = MAP_PIN_TYPE_GROUP_LEADER
			end					
		end
	else
		if unitState == AUI_MINIMAP_UNIT_IN_COMBAT and AUI.Settings.Minimap.showGroupMemberStatus then	
			if isFriend == true then
				pinType = AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_IN_COMBAT				
			else					
				pinType = AUI_MINIMAP_PIN_TYPE_GROUP_IN_COMBAT
			end
		elseif unitState == AUI_MINIMAP_UNIT_DEAD and AUI.Settings.Minimap.showGroupMemberStatus then	
			if isFriend == true then
				pinType = AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_DEAD				
			else					
				pinType = AUI_MINIMAP_PIN_TYPE_GROUP_DEAD
			end									
		elseif unitState == AUI_MINIMAP_UNIT_NORMAL or not AUI.Settings.Minimap.showGroupMemberStatus then
			if isFriend == true then
				pinType = AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND				
			else					
				pinType = MAP_PIN_TYPE_GROUP
			end					
		end
	end		
	return pinType
end

function AUI.Minimap.Pin.GetPinTextureData(self, textureData)
	if not AUI.Minimap.IsLoaded() then
		return
	end

	if(textureData ~= nil) then
		if(type(textureData) == "string") then
			return textureData
		elseif(type(textureData) == "function") then
			return textureData(self)
		end
	end
end

function AUI.Minimap.Pin.GetPinTextureColor(self, textureColor)
	if type(textureColor) == "function" then
		return textureColor(self)
	end
	
	return textureColor
end

function AUI.Minimap.Pin.RefreshPlayer()
	if not AUI.Minimap.IsLoaded() then
		return
	end

	playerPin:SetData(MAP_PIN_TYPE_PLAYER, "player")
	playerPin:UpdateSize()
end

function AUI.Minimap.Pin.RefreshPins()
	if not AUI.Minimap.IsLoaded() then
		return
	end
	
	AUI.Minimap.Pin.RefreshPlayer()
	AUI_MapPin_RefreshAllPOIs()
	AUI_MapPin_RefreshKillLocations()
	AUI_MapPin_RefreshWayshrines()
	AUI_MapPin_RefreshQuestPins()		
	AUI_MapPin_RefreshLocations()
	AUI_MapPin_RefreshGroupPins()
	AUI_MapPin_RefreshForwardCamps()
	AUI_MapPin_RefreshAvAObjectives()
	AUI_MapPin_RefreshKeeps()
	AUI_MapPin_RefreshImperialCity()
	keepNetworkManager:RefreshLinks()
	pinManager:RefreshCustomPinsByType()
end

function AUI.Minimap.Pin.RemovePins()
	pinManager:RemovePins("poi")
	pinManager:RemovePins("loc")
	pinManager:RemovePins("quest")
	pinManager:RemovePins("ava")
	pinManager:RemovePins("keep")
	pinManager:RemovePins("imperialCity")
	pinManager:RemovePins("killLocation")
	pinManager:RemovePins("fastTravelWayshrine")
	pinManager:RemovePins("forwardCamp")
	pinManager:RemovePins("group")
	pinManager:RemovePins("restrictedLink")
	pinManager:RemovePins("custom")
end


function AUI.Minimap.Pin.UpdatePinLocations()
	if not AUI.Minimap.IsLoaded() then
		return
	end

	for lookupType, lookupTable in pairs(pinManager.m_keyToPinMapping) do
		for majorIndex, keys in pairs(lookupTable) do
			for keyIndex, pinKey in pairs(keys) do
				local pin = pinManager:GetExistingObject(pinKey) 
				if pin then
					pin:UpdateLocation()
				end
			end
		end
	end	
end

function AUI.Minimap.Pin.UpdatePins()
	if not AUI.Minimap.IsLoaded() then
		return
	end

	for lookupType, lookupTable in pairs(pinManager.m_keyToPinMapping) do
		for majorIndex, keys in pairs(lookupTable) do
			for keyIndex, pinKey in pairs(keys) do
				local pin = pinManager:GetExistingObject(pinKey) 		
				if pin then
					pin:UpdateLocation()
					pin:UpdateSize()
				end
			end
		end
	end	

	keepNetworkManager:RefreshLinks()
end

function AUI.Minimap.Pin.GetPlayerPin()
	if not AUI.Minimap.IsLoaded() then
		return nil
	end

    return playerPin
end

local function AUI_Minimap_SetIconThemeData(iconThemeData, pinData)
	if pinData and iconThemeData then	
		local overlayTexture = iconThemeData["Overlay_Texture"]
		local pulseTexture = iconThemeData["Pulse_Texture"]
		local backgroundTexture = iconThemeData["Background_Texture"]	
			
		if overlayTexture and pulseTexture and backgroundTexture then		
			pinData.texture = function () return overlayTexture, pulseTexture, backgroundTexture end
		elseif overlayTexture and backgroundTexture and not pulseTexture then
			pinData.texture = function () return overlayTexture, nil, backgroundTexture end
		elseif overlayTexture and pulseTexture and not backgroundTexture then
			pinData.texture = function () return overlayTexture, pulseTexture, nil end	
		elseif overlayTexture then
			pinData.texture = function () return overlayTexture, nil, nil end		
		end	
			
		local color = iconThemeData["Color"]
	
		if color then
			pinData.tint = AUI.Color.ConvertHexToRGBA(color)
		end
	
		local isAnimated = iconThemeData["IsAnimated"]
	
		if color then
			pinData.isAnimated = isAnimated
		end
	end			
end

function AUI.Minimap.Pin.UpdateMovingPins()
	if not AUI.Minimap.IsLoaded() or not pinManager then
		return
	end

	AUI_MapPin_UpdateGroupPins()
	
	for i = 1, #AvAObjectiveContinuous do
		local pinKey = AvAObjectiveContinuous[i]
		local pin = pinManager:GetExistingObject(pinKey)
		if pin then
			local pinType, currentX, currentY = GetAvAObjectivePinInfo(pin:GetAvAObjectiveKeepId(), pin:GetAvAObjectiveObjectiveId(), pin:GetBattlegroundContext())
			pin:SetLocation(currentX, currentY)
		end
	end	
end

function AUI.Minimap.Pin.SetPinData()
	if not AUI.Minimap.IsLoaded() then
		return
	end

	AUI_MINIMAP_PIN_DATA = AUI.Table.Copy(AUI_MINIMAP_PIN_DATA_DEFAULT)
	
	for pinType, pinData in pairs(AUI_MINIMAP_PIN_DATA) do
		if pinType == MAP_PIN_TYPE_PLAYER then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_player_color)
		elseif pinType == MAP_PIN_TYPE_GROUP_LEADER then	
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_leader_normal_color)
		elseif pinType == MAP_PIN_TYPE_GROUP then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_member_normal_color)		
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_IN_COMBAT then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_leader_combat_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_DEAD then	
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_leader_dead_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_leader_friend_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_IN_COMBAT then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_leader_friend_combat_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_DEAD then	
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_leader_friend_dead_color)	
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_IN_COMBAT then				
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_member_combat_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_DEAD then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_member_dead_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND then				
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_member_friend_normal_color)	
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_IN_COMBAT then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_member_friend_combat_color)	
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_DEAD then			
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_member_friend_dead_color)					
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_MAINSTORY then	
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_mainstory_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)				
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)										
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)										
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)				
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_MAINSTORY then	
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_mainstory_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)							
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)		
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_MAINSTORY then	
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_mainstory_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)				
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)					
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_MAINSTORY then	
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_mainstory_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)				
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)										
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)			
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_MAINSTORY then	
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_mainstory_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)			
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)							
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)				
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_MAINSTORY then	
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_mainstory_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)				
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP then		
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_DAILY then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_REPEATABLE then
				AUI_MINIMAP_PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)			
		end
		
		local iconTheme = AUI.Minimap.Theme.GetCurrentMiniMapIconTheme()
		
		if iconTheme and AUI.Settings.Minimap.icon_theme ~= "default" then
			local iconThemeData = iconTheme[pinType]

			if iconThemeData then
				AUI_Minimap_SetIconThemeData(iconThemeData, AUI_MINIMAP_PIN_DATA[pinType])
			end	
		end		
	end	
end

--API

function AUI.Minimap.Pin.AddCustomPinType(pinData, callback, tooltip)
	if not AUI.Minimap.IsLoaded() or not pinManager then
		return nil
	end

	return pinManager:AddCustomPinType(pinData, callback)
end

function AUI.Minimap.Pin.CreateCustomPin(pinTypeId, pinTag, x, y, radius)
	if not AUI.Minimap.IsLoaded() or not pinManager or ZO_WorldMap_IsWorldMapShowing() then
		return
	end

	pinManager:CreateCustomPin(pinTypeId, pinTag, x, y, radius)
end


function AUI.Minimap.Pin.RefreshCustomPinsByType(pinTypeId)
	if not AUI.Minimap.IsLoaded() or not pinManager then
		return
	end
	
	pinManager:RefreshCustomPinsByType(pinTypeId)
end

function AUI.Minimap.Pin.RemoveCustomPinsByType(pinTypeId)
	if not AUI.Minimap.IsLoaded() or not pinManager then
		return
	end

	pinManager:RemoveCustomPinsByType(pinTypeId)
end

function AUI.Minimap.Pin.RefreshGroupPins()
	if not AUI.Minimap.IsLoaded() or not pinManager then
		return
	end

	AUI_MapPin_RefreshGroupPins()
end

function AUI.Minimap.Pin.RefreshQuestPins()
	if not AUI.Minimap.IsLoaded() or not pinManager then
		return
	end

	AUI_MapPin_RefreshQuestPins()
end

function AUI.Minimap.Pin.RefreshSingleQuestPin(journalIndex)
	if not AUI.Minimap.IsLoaded() or not pinManager then
		return
	end

	AUI_MapPin_RefreshSingleQuestPin(journalIndex)
end

function AUI.Minimap.Pin.AddQuestPin(taskId, pinType, xLoc, yLoc, areaRadius, insideCurrentMapWorld, isBreadcrumb)
	if not AUI.Minimap.IsLoaded() or not pinManager then
		return
	end
	
	AUI_MapPin_AddQuestPin(taskId, pinType, xLoc, yLoc, areaRadius, insideCurrentMapWorld, isBreadcrumb)	
end

function AUI.Minimap.Pin.RefreshKeep(keepId, bgContext)
	if not AUI.Minimap.IsLoaded() or not pinManager or not IsLocalBattlegroundContext(bgContext) then
		return
	end	
	
	AUI_MapPin_RefreshKeeps(keepId)
end
